/****************************************************************************\
*                                                                            *
* New World IV Source Copyright (c) James Ferry 2001                         *
* NWIV site - http://www.dukeworld.com/nw4/nwiv                              *
*                                                                            *
* "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman               *
* Ken Silverman's official web site: "http://www.advsys.net/ken"             *
* See the included license file "BUILDLIC.TXT" for license info.             *
* This file has been modified from Ken Silverman's original release          *
*                                                                            *
*                                                                            *
* Release 1                                                                  *
* The enemy AI is a bit dodgey.  The movement code is still the same as the  *
* original build engine (ie I haven't put my version in yet), so if a        *
* monster walks down a wall it will crash.                                   *
* I haven't commented anything in this thing, it is just as I use it.        *
*                                                                            *
* WAVE.C                                                                     *
* used in the sound editor                                                   *
*                                                                            *
\****************************************************************************/
//#define kinp(x) inp(x)
//#define koutp(x,y) outp(x,y)

long SND_VOLUME=256L;

#pragma aux koutp =\
	"out dx, al",\
	parm [edx][eax]\
	modify exact \

#pragma aux kinp =\
	"in al, dx",\
	parm nomemory [edx]\
	modify exact [eax]\

volatile long totalclock;
#define MAXWAVES 1024
#define W_NAM 20
short SCREEN_SIZE=23;
short DISPLAY_SIZE=92;
//long voxel_lod=2621440;
extern char nwd[1024];
char oldwd[1024];
typedef struct _wavheader
{
char type1[4];
long a;
char type2[8];
long b1;
short frmt;
unsigned short chan;
unsigned long b3;
unsigned long b4;
unsigned short d1;
unsigned short d2;
char type3[4];
long c;
}WAVHEADER;
WAVHEADER wavheader[MAXWAVES];


short instnum=0;
short viewinst=0;
short icon_rotate=0;
extern short searchsector, searchwall, searchstat;     //search output
char last_hit=0;
long accuracy=0;
long shots=0;
long shots_count[100];

#include <dos.h>
#include <fcntl.h>
//#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
//#include <dos.h>
#include "build.h"

#define TIMERINTSPERSECOND 280
#define MOVESPERSECOND 40
#define TICSPERFRAME 3
#define MOVEFIFOSIZ 256

#pragma aux printchrasm =\
	"add edi, 0xb8000"\
	"rep stosw"\
	parm [edi][ecx][eax]\

#define deletewave() clearwave(--numwaves)


print(int x, int y, unsigned char string[81], unsigned char foreground, unsigned char background)
{
	unsigned char character;
   int attributes;
	int i, pos;
   attributes=background*16+foreground;
	pos = (y*80+x)<<1;
	i = 0;
	while (string[i] != 0)
	{
		character = string[i];
      printchrasm(pos,1,(attributes<<8)+(int)character);
		i++;
		pos+=2;
	}
}

printstr(int x, int y, unsigned char string[81], unsigned char attribute)
{
	unsigned char character;
	int i, pos;

	pos = (y*80+x)<<1;
	i = 0;
	while (string[i] != 0)
	{
		character = string[i];
		printchrasm((int)pos,1,((int)attribute<<8)+(int)character);
		i++;
		pos+=2;
	}
}


printc(int x, int y, unsigned char character, unsigned char foreground, unsigned char background)
{
   printchrasm((y*80+x)<<1,1,((int)(background*16+foreground)<<8)+(int)character);
}


void (__interrupt __far *oldtimerhandler)();
void __interrupt __far timerhandler(void);

#define KEYFIFOSIZ 64
void (__interrupt __far *oldkeyhandler)();
void __interrupt __far keyhandler(void);
volatile char keystatus[256], keyfifo[KEYFIFOSIZ], keyfifoplc, keyfifoend;
volatile char readch, oldreadch, extended, keytemp;

static long fvel, svel, avel;
static long fvel2, svel2, avel2;

#define NUMOPTIONS 8
#define NUMKEYS 21
static long vesares[13][2] = {320,200,360,200,320,240,360,240,320,400,
									360,400,640,350,640,400,640,480,800,600,
                           1024,768,1280,1024,1600,1280};
static char option[NUMOPTIONS] = {0,0,0,0,0,0,1,0};
static char info_hud=0;
static char nightvision=0;
static char keys[NUMKEYS] =
{
	0xc8,0xd0,0xcb,0xcd,0x2a,0x9d,0x1d,0x39,
	0x1e,0x2c,0xd1,0xc9,0x33,0x34,
   0x9c,0x1c,0xd,0xc,0xf,0x31,0x17,
};

static long digihz[7] = {6000,8000,11025,16000,22050,32000,44100};

static char frame2draw[MAXPLAYERS];
static long frameskipcnt[MAXPLAYERS];

#define LAVASIZ 128
#define LAVALOGSIZ 7
#define LAVAMAXDROPS 32
static char lavabakpic[(LAVASIZ+4)*(LAVASIZ+4)], lavainc[LAVASIZ];
static long lavanumdrops, lavanumframes;
static long lavadropx[LAVAMAXDROPS], lavadropy[LAVAMAXDROPS];
static long lavadropsiz[LAVAMAXDROPS], lavadropsizlookup[LAVAMAXDROPS];
static long lavaradx[24][96], lavarady[24][96], lavaradcnt[32];

	//Input structures
	//Input faketimerhandler -> movethings fifo
faketimerhandler(){}
static long movefifoplc, movefifoend[MAXPLAYERS];
//static input baksync[MOVEFIFOSIZ][MAXPLAYERS];
   //Game recording variables
static long reccnt, recstat = 1;
//static input recsync[16384][2];

static signed char otherlag[MAXPLAYERS] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
static long averagelag[MAXPLAYERS] = {512,512,512,512,512,512,512,512,512,512,512,512,512,512,512,512};

static long fakemovefifoplc;
static long myx, myy, myz, omyx, omyy, omyz, myzvel;
static long myhoriz, omyhoriz;
static short myang, omyang, mycursectnum;
static long myxbak[MOVEFIFOSIZ], myybak[MOVEFIFOSIZ], myzbak[MOVEFIFOSIZ];
static long myhorizbak[MOVEFIFOSIZ];
static short myangbak[MOVEFIFOSIZ];

	//MULTI.OBJ sync state variables
extern char syncstate;
	//GAME.C sync state variables
static char syncstat, syncval[MOVEFIFOSIZ], othersyncval[MOVEFIFOSIZ];
static long syncvaltottail, syncvalhead, othersyncvalhead, syncvaltail;

static char detailmode = 0, ready2send = 0;
static long ototalclock = 0, gotlastpacketclock = 0, smoothratio;
static long oposx[MAXPLAYERS], oposy[MAXPLAYERS], oposz[MAXPLAYERS];
static long ohoriz[MAXPLAYERS], ozoom[MAXPLAYERS];
static short oang[MAXPLAYERS];

//static point3d osprite[MAXSPRITES];

#define MAXINTERPOLATIONS 1024
static long numinterpolations = 0, startofdynamicinterpolations = 0;
static long oldipos[MAXINTERPOLATIONS];
static long bakipos[MAXINTERPOLATIONS];
static long *curipos[MAXINTERPOLATIONS];

extern long cachecount, transarea;

static char playerreadyflag[MAXPLAYERS];

	//Miscellaneous variables
static char packbuf[MAXXDIM];
static char tempbuf[MAXXDIM], boardfilename[80];
static short tempshort[MAXSECTORS];
static short screenpeek = 0, oldmousebstatus = 0, brightness = 0;
static short screensize, screensizeflag = 0;
static short neartagsector, neartagwall, neartagsprite;
static long lockclock, neartagdist, neartaghitdist;
extern long frameplace, pageoffset, ydim16;
static long globhiz, globloz, globhihit, globlohit;
static long stereomode = 0;
extern long stereowidth, stereopixelwidth, activepage;

	//Over the shoulder mode variables
static long cameradist = -1, cameraang = 0, cameraclock = 0;

	//Board animation variables
#define MAXMIRRORS 64
static short mirrorwall[MAXMIRRORS], mirrorsector[MAXMIRRORS], mirrorcnt;
static short floormirrorsector[64], floormirrorcnt;
static short turnspritelist[16], turnspritecnt;
static short warpsectorlist[64], warpsectorcnt;
static short xpanningsectorlist[16], xpanningsectorcnt;
static short ypanningwalllist[64], ypanningwallcnt;
static short floorpanninglist[64], floorpanningcnt;
static short dragsectorlist[16], dragxdir[16], dragydir[16], dragsectorcnt;
static long dragx1[16], dragy1[16], dragx2[16], dragy2[16], dragfloorz[16];
static short swingcnt, swingwall[32][5], swingsector[32];
static short swingangopen[32], swingangclosed[32], swingangopendir[32];
static short swingang[32], swinganginc[32];
static long swingx[32][8], swingy[32][8];
static short revolvesector[4], revolveang[4], revolvecnt;
static long revolvex[4][16], revolvey[4][16];
static long revolvepivotx[4], revolvepivoty[4];
static short subwaytracksector[4][128], subwaynumsectors[4], subwaytrackcnt;
static long subwaystop[4][8], subwaystopcnt[4];
static long subwaytrackx1[4], subwaytracky1[4];
static long subwaytrackx2[4], subwaytracky2[4];
static long subwayx[4], subwaygoalstop[4], subwayvel[4], subwaypausetime[4];
static short waterfountainwall[MAXPLAYERS], waterfountaincnt[MAXPLAYERS];
static short slimesoundcnt[MAXPLAYERS];

	//Variables that let you type messages to other player
static char getmessage[162], getmessageleng;
static long getmessagetimeoff;
static char typemessage[162], typemessageleng = 0, typemode = 0;
static char scantoasc[128] =
{
	0,0,'1','2','3','4','5','6','7','8','9','0','-','=',0,0,
	'q','w','e','r','t','y','u','i','o','p','[',']',0,0,'a','s',
	'd','f','g','h','j','k','l',';',39,'`',0,92,'z','x','c','v',
	'b','n','m',',','.','/',0,'*',0,32,0,0,0,0,0,0,
	0,0,0,0,0,0,0,'7','8','9','-','4','5','6','+','1',
	'2','3','0','.',0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
};
static char scantoascwithshift[128] =
{
	0,0,'!','@','#','$','%','^','&','*','(',')','_','+',0,0,
	'Q','W','E','R','T','Y','U','I','O','P','{','}',0,0,'A','S',
	'D','F','G','H','J','K','L',':',34,'~',0,'|','Z','X','C','V',
	'B','N','M','<','>','?',0,'*',0,32,0,0,0,0,0,0,
	0,0,0,0,0,0,0,'7','8','9','-','4','5','6','+','1',
	'2','3','0','.',0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
};

	//These variables are for animating x, y, or z-coordinates of sectors,
	//walls, or sprites (They are NOT to be used for changing the [].picnum's)
	//See the setanimation(), and getanimategoal() functions for more details.
#define MAXANIMATES 512
static long *animateptr[MAXANIMATES], animategoal[MAXANIMATES];
static long animatevel[MAXANIMATES], animateacc[MAXANIMATES], animatecnt = 0;

	//These parameters are in exact order of sprite structure in BUILD.H
#define spawnsprite(newspriteindex2,x2,y2,z2,cstat2,shade2,pal2,       \
		clipdist2,xrepeat2,yrepeat2,xoffset2,yoffset2,picnum2,ang2,      \
		xvel2,yvel2,zvel2,owner2,sectnum2,statnum2,lotag2,hitag2,extra2) \
{                                                                      \
	spritetype *spr2;                                                   \
	newspriteindex2 = insertsprite(sectnum2,statnum2);                  \
	spr2 = &sprite[newspriteindex2];                                    \
	spr2->x = x2; spr2->y = y2; spr2->z = z2;                           \
	spr2->cstat = cstat2; spr2->shade = shade2;                         \
	spr2->pal = pal2; spr2->clipdist = clipdist2;                       \
	spr2->xrepeat = xrepeat2; spr2->yrepeat = yrepeat2;                 \
	spr2->xoffset = xoffset2; spr2->yoffset = yoffset2;                 \
	spr2->picnum = picnum2; spr2->ang = ang2;                           \
	spr2->xvel = xvel2; spr2->yvel = yvel2; spr2->zvel = zvel2;         \
	spr2->owner = owner2;                                               \
	spr2->lotag = lotag2; spr2->hitag = hitag2; spr2->extra = extra2;   \
	copybuf(&spr2->x,&osprite[newspriteindex2].x,3);                    \
	show2dsprite[newspriteindex2>>3] &= ~(1<<(newspriteindex2&7));      \
	if (show2dsector[sectnum2>>3]&(1<<(sectnum2&7)))                    \
		show2dsprite[newspriteindex2>>3] |= (1<<(newspriteindex2&7));    \
}                                                                      \

// vox
   #define VOX_PLAYER_NUM 0L
   #define VOX_WORM_NUM 1L
   #define VOX_HEAD_NUM 2L
   #define VOX_BOTTLE_NUM 3L
   #define VOX_PLAYER_REF 0
   #define VOX_WORM_REF 1
   #define VOX_HEAD_REF 2
   #define VOX_BOTTLE_REF 3

extern long numwaves;
extern char instname[MAXWAVES][16];
#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

predisplaywave()
{
 long i,b,j,k;
 setvmode(0x3);
 printc(0,0,218,7,0);
 for(i=1;i<79;i++)
  printc(i,0,i%20?196:194,7,0);
 printc(79,0,191,7,0);
 for(j=1;j<24;j++)
 {
  for(i=0;i<79;i++)
   printc(i,j,i%20?32:179,7,0);
  printc(79,j,179,7,0);
 }
 printc(0,24,192,7,0);
 for(i=1;i<79;i++)
  printc(i,24,i%20?196:193,7,0);
 printc(79,24,217,7,0);
 //193
 //192
 //217
 //179
 //218
 //194
 //196
 //191
// print(W_NAM+2,1,"Instrument Name ",4,0);
}
displaywave(short num,short highlight)
{
 long i,b,j,k;
 char string[80];
 b=numwaves>=num+SCREEN_SIZE?num+SCREEN_SIZE:numwaves;
 for(j=1;j<24;j++)
 {
  for(i=0;i<79;i++)
   printc(i,j,i%20?32:179,7,0);
  printc(79,j,179,7,0);
 }

 for(i=num;i<b;i++)
 for(k=0;k<4;k++)
 {
 if(i+k*SCREEN_SIZE==highlight)
 {
 if(k==3)
  sprintf(string,"%c                  %c",221,222);
 else
  sprintf(string,"%c                   %c",221,222);
  print(k*W_NAM,i-num+1,string,0,5);
 }
 else
 {
  sprintf(string,"                 ",221,222);
  print(2+k*W_NAM,i-num+1,string,0,0);
 }
//  print(k*W_NAM,i-num+1,"                ",i+k*SCREEN_SIZE==highlight?15:7,i+k*SCREEN_SIZE==highlight?5:0);
  for(j=0;j<16;j++)
   string[j]=instname[i+k*SCREEN_SIZE][j];
  string[16]=0;
  print(2+k*W_NAM,i-num+1,string,            i+k*SCREEN_SIZE==highlight?15:7,i+k*SCREEN_SIZE==highlight?5:0);
 }
}

extern long splc[16];
extern char filetypes[MAXWAVES];
main(short int argc,char **argv)
{
   long i, j, k, l, waitplayers, x1, y1, x2, y2;
	short other, packleng;
   char string[80];
   long li, lk, lj;
   FILE *lin,*fil;
	char *ptr;
// putenv("DOS4G=quiet");
for(i=0;i<MAXWAVES;i++)
  filetypes[i]=1;

getcwd(oldwd,1024);


   if ((fil = fopen("setup.dat","rb"))!=NULL)
	{
      fread(option,1,NUMOPTIONS,fil);
//      fread(&keys[0],1,NUMKEYS,fil);
      fclose(fil);
	}
/*
   if ((fil = open("setup.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&option[0],NUMOPTIONS);
		read(fil,&keys[0],NUMKEYS);
		close(fil);
	}
*/
   initkeys();
	inittimer();
	initsb(option[1],option[2],digihz[option[7]>>4],((option[7]&4)>0)+1,((option[7]&2)>0)+1,60,option[7]&1);
//getcwd(nwd,1024);
//chdir(oldwd);
   loadwaves("waves.kwv");
//return 0;
//chdir(nwd);


if(argc>1)
{
sprintf(nwd,"%s",argv[1]);
chdir(nwd);
}
else
sprintf(nwd,".");


predisplaywave();
   displaywave(viewinst,instnum);



	reccnt = 0;
   totalclock = ototalclock = 0; gotlastpacketclock = 0;

	ready2send = 1;
   // 0xc8,0xd0
	while (!keystatus[1])       //Main loop starts here
	{
			// backslash (useful only with KDM)
		if (keystatus[0x2b]) { keystatus[0x2b] = 0; preparesndbuf(); }

if(keystatus[0x1f]) // s
{
keystatus[0x1f]=0;
//savewaves("waves.kwv");
getcwd(nwd,1024);
chdir(oldwd);
savewaves("waves.kwv");
chdir(nwd);
}


if(keystatus[0x26]) // l
{
keystatus[0x26]=0;
instnum=0;
viewinst=0;
getcwd(nwd,1024);
chdir(oldwd);
   loadwaves("waves.kwv");
chdir(nwd);
predisplaywave();
   displaywave(viewinst,instnum);
}

   if (keystatus[0x1c]) // enter
//   if (keystatus[0x32])  // m
   {
   keystatus[0x1c]=0;
//filehandle();
filehandle();
getcwd(nwd,1024);
   }
   if (keystatus[0x31])  // N
   {
    splc[0]=0;
    keystatus[0x31]=0;
    uninitkeys();
    gets(string);
    memcpy(instname[instnum],string,16);
    initkeys();
    predisplaywave();
    displaywave(viewinst,instnum);
   }
   if (keystatus[0xd3])  // delete
   {
      splc[0]=0;
   keystatus[0xd3]=0;
   clearwave(instnum);
   displaywave(viewinst,instnum);
   }
   if(keystatus[0xd2]) // insert
   {
    keystatus[0xd2]=0;
    insertwave();
   }

//deletewave();

   if (keystatus[0x39])  // Space
   {
      splc[0]=0;
      keystatus[0x39] = 0;
      wsay(instname[instnum],4096L,SND_VOLUME,SND_VOLUME);
   }

   if (
   keystatus[0xc8]||
   keystatus[0xd0]||
   keystatus[0xcb]||
   keystatus[0xcd]||
   keystatus[0xc9]||
   keystatus[0xd1]||
   keystatus[0xc7]||
   keystatus[0xcf]
   )  // scroll
   {
   i=instnum;
   if(keystatus[0xc8])instnum--;
   if(keystatus[0xd0])instnum++;
   if(keystatus[0xcb])instnum-=SCREEN_SIZE;
   if(keystatus[0xcd])instnum+=SCREEN_SIZE;
   if(keystatus[0xc9])instnum-=DISPLAY_SIZE;
   if(keystatus[0xd1])instnum+=DISPLAY_SIZE;
   if(keystatus[0xc7])instnum=0;
   if(keystatus[0xcf])instnum=numwaves-1;

   if(instnum<=0)instnum=0;
   if(instnum>numwaves-1)instnum=numwaves-1;
   if(keystatus[0xcb]) if(viewinst>instnum)viewinst-=SCREEN_SIZE;
   if(keystatus[0xcd]) if(instnum-viewinst>=DISPLAY_SIZE)viewinst+=SCREEN_SIZE;
   if(keystatus[0xc8]) if(viewinst>instnum)viewinst-=SCREEN_SIZE;
   if(keystatus[0xd0]) if(instnum-viewinst>=DISPLAY_SIZE)viewinst+=SCREEN_SIZE;
   if(keystatus[0xc9]) while(viewinst>instnum)viewinst-=SCREEN_SIZE;
   if(keystatus[0xd1]) while(instnum-viewinst>=DISPLAY_SIZE)viewinst+=SCREEN_SIZE;
   if(keystatus[0xc7]) while(viewinst>instnum)viewinst-=SCREEN_SIZE;
   if(keystatus[0xcf]) while(instnum-viewinst>=DISPLAY_SIZE)viewinst+=SCREEN_SIZE;
   if(i!=instnum)
   {
      splc[0]=0;
      displaywave(viewinst,instnum);
      if(keystatus[0x1d]||keystatus[0x9d])
         wsay(instname[instnum],4096L,SND_VOLUME,SND_VOLUME);
   }
   keystatus[0xc8]=0;
   keystatus[0xd0]=0;
   keystatus[0xcb]=0;
   keystatus[0xcd]=0;
   keystatus[0xc9]=0;
   keystatus[0xd1]=0;
   keystatus[0xc7]=0;
   keystatus[0xcf]=0;
   }
      i = (totalclock-gotlastpacketclock)*(65536/(TIMERINTSPERSECOND/MOVESPERSECOND));
	}

	uninittimer();
	uninitkeys();
	uninitsb();
   setvmode(0x3);        //Set back to text mode
   chdir(oldwd);
   return(0);
}

inittimer()
{
	outp(0x43,0x34);
	outp(0x40,(1193181/TIMERINTSPERSECOND)&255);
	outp(0x40,(1193181/TIMERINTSPERSECOND)>>8);
	oldtimerhandler = _dos_getvect(0x8);
	_disable(); _dos_setvect(0x8, timerhandler); _enable();
}

uninittimer()
{
	outp(0x43,0x34); outp(0x40,0); outp(0x40,0);
	_disable(); _dos_setvect(0x8, oldtimerhandler); _enable();
}

void __interrupt __far timerhandler()
{
	totalclock++;
   _chain_intr(oldtimerhandler);
	outp(0x20,0x20);
}

initkeys()
{
	long i;

	keyfifoplc = 0; keyfifoend = 0;
	for(i=0;i<256;i++) keystatus[i] = 0;
	oldkeyhandler = _dos_getvect(0x9);
	_disable(); _dos_setvect(0x9, keyhandler); _enable();
}

uninitkeys()
{
	short *ptr;

	_dos_setvect(0x9, oldkeyhandler);
		//Turn off shifts to prevent stucks with quitting
	ptr = (short *)0x417; *ptr &= ~0x030f;
}

void __interrupt __far keyhandler()
{
	koutp(0x20,0x20);
	oldreadch = readch; readch = kinp(0x60);
	keytemp = kinp(0x61); koutp(0x61,keytemp|128); koutp(0x61,keytemp&127);
	if ((readch|1) == 0xe1) { extended = 128; return; }
	if (oldreadch != readch)
	{
		if ((readch&128) == 0)
		{
			keytemp = readch+extended;
			if (!keystatus[keytemp])
			{
				keystatus[keytemp] = 1;
				keyfifo[keyfifoend] = keytemp;
				keyfifo[(keyfifoend+1)&(KEYFIFOSIZ-1)] = 1;
				keyfifoend = ((keyfifoend+2)&(KEYFIFOSIZ-1));
			}
		}
		else
		{
			keytemp = (readch&127)+extended;
			keystatus[keytemp] = 0;
			keyfifo[keyfifoend] = keytemp;
			keyfifo[(keyfifoend+1)&(KEYFIFOSIZ-1)] = 0;
			keyfifoend = ((keyfifoend+2)&(KEYFIFOSIZ-1));
		}
	}
	extended = 0;
}

